<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <title>Directly accessing Street View data</title>
    <style>
      html, body {
        height: 100%;
        margin: 0;
        padding: 0;
      }
      #map {
        height: 100%;
      }
    </style>
     <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.12.4/jquery.min.js"></script>
     <script async defer
    src="https://maps.googleapis.com/maps/api/js?key=AIzaSyCUlQEVELKOBQi39VWgb7jjjq4a4lq9jdU&callback=initMap">
    </script>
  </head>
  <body>
    <div id="map" style="width: 45%; height: 100%;float:left"></div>
    <div id="pano" style="width: 45%; height: 100%;float:left"></div>
    <script>
    
    var ROTATE_DEGS_PER_SEC = 60.0;           // Will take ~12 secs (360/60) for full revolution.
	var ROTATE_DELAY_SECS = 2.5;              // Wait 3 seconds to start.
	var ROTATE_FPS = 100.0;                   // Frames per second for rotate.
	var panoLastTouchTimestamp = Date.now();  // Timestamp pano loaded in milliseconds.
	var masterAnimate = true;                 // Set false to stop all animation.
	var panoHeadingAngle = 0;                 // Current heading of pano.

      /*
       * Click the map to set a new location for the Street View camera.
       */

      var map;
      var panorama;

      function initMap() {
        var berkeley = {lat: 25.1943209, lng: 55.2742231};
        var sv = new google.maps.StreetViewService();

        panorama = new google.maps.StreetViewPanorama(document.getElementById('pano'));

        // Set up the map.
        map = new google.maps.Map(document.getElementById('map'), {
          center: berkeley,
          zoom: 16,
          streetViewControl: false
        });

        // Set the initial Street View camera to the center of the map
        sv.getPanorama({location: berkeley, radius: 50}, processSVData);

        // Look for a nearby Street View panorama when the map is clicked.
        // getPanoramaByLocation will return the nearest pano when the
        // given radius is 50 meters or less.
        map.addListener('click', function(event) {
        console.log(event.latLng);
          sv.getPanorama({location: event.latLng, radius: 50}, processSVData);
        });
         panoLastTouchTimestamp = Date.now();
 
 
 $("#pano").on("mouseenter", function () {
      masterAnimate = false;
      panoLastTouchTimestamp = 0;
    });

    $("#pano").on("mouseleave", function () { 
    	masterAnimate = true;
    	panoLastTouchTimestamp = 0;
    });
    
	  
    // Add animation which rotates our pano.
     window.setInterval(function() {
     if (masterAnimate == false) {
	return;
      }
      if (Date.now() < panoLastTouchTimestamp + ROTATE_DELAY_SECS * 1000) {
	console.log(Math.floor(Date.now() / 1000));
	return;
      }
      var pov = panorama.getPov();
      pov.heading += ROTATE_DEGS_PER_SEC / ROTATE_FPS;
      panoHeadingAngle = pov.heading;
      panorama.setPov(pov);
    }, 1000 / ROTATE_FPS);
 
    // Add a click listener which delays rotation.
    panorama.addListener('pov_changed', function() {
      // Check that change in POV is a user click, versus expected animation.
      var pov = panorama.getPov();
      if (panoHeadingAngle != pov.heading) {
	panoLastTouchTimestamp = Date.now();  // Will cease animation for a while.
      }
    });
	  
      }

      function processSVData(data, status) {
        if (status === 'OK') {
          var marker = new google.maps.Marker({
           // position: data.location.latLng,
            map: map,
            title: data.location.description
          });

          panorama.setPano(data.location.pano);
          panorama.setPov({
            heading: 270,
            pitch: 0
          });
          panorama.setVisible(true);

          marker.addListener('click', function() {
            var markerPanoID = data.location.pano;
            // Set the Pano to use the passed panoID.
            panorama.setPano(markerPanoID);
            panorama.setPov({
              heading: 270,
              pitch: 0
            });
            panorama.setVisible(true);
          });
        } else {
          console.error('Street View data not found for this location.');
        }
      }
    </script>
    
  </body>
</html>
